/* eslint-disable */
/**liuwh
 * 5/29/2020, 9:55:19 AM
 * doc comment for the file goes here
 */

/** 绩效总览 */
import React, { ReactNode, ReactEventHandler, Component } from 'react';
import { Row, Col, Divider } from 'antd';
import TableView from '../../../common/TableView';
import SearchFormView from '../../../common/SearchFormView';
import { createHashHistory } from 'history';
import fetch from '../../../../api/request';
import './index.scss';
import moment from 'moment';

const history = createHashHistory();

export default class MeritsOverview extends Component {
  constructor(props) {
    super(props);
    this.config = {
    };
    this.state = {
      formData: {
        __key: Date.now(),
        page: 1,
        size: 10,
        countMonth: moment().month(moment().month() - 1).format('YYYY-MM')
      },
      queryTerms: null
    };
  }

  componentDidMount() {
    this.loadqueryTerms()
  }

  loadqueryTerms = () => {
    fetch({
      url: `api/merits/assess/queryTerms`,
    }).then(res => {
      if (res) {
        console.log('res', res);
        this.setState({ queryTerms: res })
      }
    })
  }

  setFormData = data => {
    console.log('form', data);
    this.setState({
      formData: data,
    });
  }

  linkDetail = (item) => {
    let { userId, countMonth } = item;
    history.push(`/merits/meritsOverview/meritsDetail/${userId}/true/${countMonth}`)
  }

  renderColumns = () => {
    return [
      { title: '序号', dataIndex: 'index' },
      { title: '姓名', dataIndex: 'userName' },
      { title: '部门', dataIndex: 'userDeptName' },
      { title: '岗位', dataIndex: 'meritsPostName' },
      { title: '考评月份', dataIndex: 'countMonth' },
      { title: '总任务数', dataIndex: 'taskNumber' },
      { title: '总缺陷数', dataIndex: 'defectNumber' },
      { title: '考评得分(分)', dataIndex: 'meritsGrade' },
      {
        title: '操作', dataIndex: 'operation', render: (cur, item) => {
          return <Row>
            <a onClick={() => this.linkDetail(item)}>详情</a>
          </Row>
        }
      },
    ];
  }



  render() {
    const { formData, queryTerms } = this.state;

    let tableParams = {
      url: `api/merits/assess/queryMerits`,
      formData,
      key: formData.__key,
      columns: this.renderColumns(),
      extraFromData: {},
      setFormData: this.setFormData
    }

    function disabledDate(current) {
      return current && current >= moment().endOf('day');
    }

    return (
      <div className="merits-overview-main">
        {
          queryTerms &&
          <SearchFormView
            formData={formData}
            setFormData={this.setFormData}
            data={[
              { type: 'select', name: '部门', label: '部门', key: 'userDeptId', list: queryTerms.dept ? queryTerms.dept.map(({ name, id }) => ({ name, value: id })) : [], },
              { type: 'select', name: '岗位', label: '岗位', key: 'meritsPostId', list: queryTerms.post ? queryTerms.post.map(({ name, id }) => ({ name, value: id })) : [], },
              { type: 'input', name: '姓名', label: '姓名', key: 'userName' },
              {
                type: 'monthPicker',
                label: '考评月份',
                name: '考评月份',
                key: 'countMonth',
                disabledDate
              },
            ]} />
        }
        <TableView {...tableParams} />
      </div>
    )
  }
}

